/* Simple Railway Crossing Example for Spin.
 * This version uses explicit stuttering, as in NuSMV, which 
 * is not really necessary in Spin.
 */

mtype = { appr, xing, lvng, away }
mtype = { open, clos }

int train = away;
int car   = away;
int gate  = open;

proctype Train() {
   do 
   :: train == away -> train = appr;
   :: train == away -> train = away;
   :: train == appr && gate != open -> train = xing; 
   :: train == appr && gate == open -> train = appr;
   :: train == xing -> train = lvng; 
   :: train == lvng -> train = away;
   od
   }

proctype Car () {
   do
   :: car == away -> car = appr;
   :: car == away -> car = away;
   :: car == appr && gate == open -> car = xing; 
   :: car == appr && gate != open -> car = appr;
   :: car == xing && gate == open -> car = lvng; 
   :: car == xing && gate != open -> car = xing;
   :: car == lvng -> car = away;
   od
   }

proctype Gate() {
   do
   :: gate == open && train == appr -> gate = clos;
   :: gate == open && train != appr -> gate = open;
   :: gate == clos && train == lvng -> gate = open;
   :: gate == clos && train != lvng -> gate = clos;
   od
   }

init {
  run Gate();
  run Train();
  run Car();
  }

ltl safety { [] (! (car == xing && train == xing)) } 
