/* The simple Railway Crossing Example for Spin.
 * 
 * Because Spin is asynchronous, we do not need "stuttering" steps for the car
 * and train as in NuSMV. Of course, the system is still unsafe.
 */

mtype = { appr, xing, lvng, away }
mtype = { open, clos }

int train = away;
int car   = away;
int gate  = open;

proctype Train() {
   do 
   :: train == away -> train = appr;
   :: train == appr && gate == clos -> train = xing;
   :: train == xing -> train = lvng; 
   :: train == lvng -> train = away;
   od
   }

proctype Car () {
   do
   :: car == away -> car = appr;
   :: car == appr && gate == open -> car = xing; 
   :: car == xing -> car = lvng; 
   :: car == lvng -> car = away;
   od
   }

proctype Gate() {
   do
   :: gate == open && train == appr -> gate = clos;
   :: gate == clos && train == lvng -> gate = open;
   od
   }

init {
  run Gate();
  run Train();
  run Car();
  }

ltl safety { [] (! (car == xing && train == xing)) } 
